/****************************************************************

	CM01 Control Program Ver.2.2

						2015.7.18	M.Ustumi@ARCDEVICE

******************************************************************/

#include"stdio.h"
#include"math.h"

#include"ControlModule.h"
#include"Ad.h"
#include"Encoder.h"
#include"MotorPWM.h"
#include"MotorDA.h"

#define CM01_GET_CONFIG		50
#define CM01_CLEAR_DATA		51
#define CM01_EXCHANGE		150

typedef struct _CM01_INPUT_ENC
{
	long lEncoder;
	WORD wSensor[5];
} CM01_INPUT_ENC;

#define CM01_INPUT_ENC_SIZE	14

typedef struct _CM01_INPUT_SENSOR
{
	WORD wSensor[8];
} CM01_INPUT_SENSOR;

#define CM01_INPUT_SENSOR_SIZE 16

typedef struct _CM01_OUTPUT_PWM
{
	short sPwm1;
	short sPwm2;
} CM01_OUTPUT_PWM;

#define CM01_OUTPUT_PWM_SIZE 4

#define CM01_OUTPUT_PWM_SIZE 4

typedef struct _CM01_OUTPUT_DA
{
	short sDA;
} CM01_OUTPUT_DA;

#define CM01_OUTPUT_DA_SIZE 2

typedef union _CM01_PIO
{
	struct{
		WORD wData;
		WORD wDir;
	} Word;
	struct{
		unsigned P0: 1;
		unsigned P1: 1;
		unsigned P2: 1;
		unsigned P3: 1;
		unsigned P4: 1;
		unsigned P5: 1;
		unsigned P6: 1;
		unsigned P7: 1;

		unsigned P8:  1;
		unsigned P9:  1;
		unsigned P10: 1;
		unsigned P11: 1;
		unsigned P12: 1;
		unsigned P13: 1;
		unsigned P14: 1;
		unsigned P15: 1;

		unsigned DIR0:  1;
		unsigned DIR1:  1;
		unsigned DIR2:  1;
		unsigned DIR3:  1;
		unsigned DIR4:  1;
		unsigned DIR5:  1;
		unsigned DIR6:  1;
		unsigned DIR7:  1;

		unsigned DIR8:  1;
		unsigned DIR9:  1;
		unsigned DIR10: 1;
		unsigned DIR11: 1;
		unsigned DIR12: 1;
		unsigned DIR13: 1;
		unsigned DIR14: 1;
		unsigned DIR15: 1;
	} Bit;

} CM01_PIO;

#define CM01_INPUT_PIO_SIZE		2
#define CM01_OUTPUT_PIO_SIZE	4

BYTE bBoardID_PA;
BYTE bBoardID_PB;

short sInputDataSize_PA;
short sOutputDataSize_PA;
short sInputDataSize_PB;
short sOutputDataSize_PB;
BYTE* pInputData_PA;
BYTE* pOutputData_PA;
BYTE* pOutputData_PB;
BYTE* pInputData_PB;

CM01_INPUT_ENC EncBoard;
CM01_INPUT_SENSOR SensorBoard;
CM01_OUTPUT_PWM PwmBoard;
CM01_OUTPUT_DA DaBoard;
CM01_PIO PioBoardA;
CM01_PIO PioBoardB;

/******************************************************************

 ^C}
 ̓^C}1ōC̊荞݂CM_ControlTrigTRUEɂD
 C䃋[`CM_ControlTrigTRUEɂȂ܂ő҂̏sD
CM_ControlTrig̓C䃋[`FALSEɂD

******************************************************************/


void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt( void )
{
	IFS0bits.T1IF = 0;
	UT_ControlTrig = TRUE;

	//if( CM_wCtrlTimeout > 0 ) CM_wCtrlTimeoutCount++;
	if( ESPI1_wTimeout > 0 ) ESPI1_wTimeoutCount++;

	ENCODER_Count();	// GR[_l莞Ԃŕۑ
	
}

void ProcEncoder( void )
{
	EncBoard.lEncoder = ENCODER_Counter.count_32; // 32bit΃JEgl
	
	EncBoard.wSensor[0] = AD_GetData( 0 );
	EncBoard.wSensor[1] = AD_GetData( 1 );
	EncBoard.wSensor[2] = AD_GetData( 5 );
	EncBoard.wSensor[3] = AD_GetData( 6 );
	EncBoard.wSensor[4] = AD_GetData( 7 );
}

void ProcSensor( void )
{
	short ch;

	for(ch=0;ch<8;ch++ ) SensorBoard.wSensor[ch] = AD_GetData( ch );

}

void ProcPWM( void )
{
	MOTOR_Drive( 0, PwmBoard.sPwm1 );
	MOTOR_Drive( 1, PwmBoard.sPwm2 );
}

void ProcDA( void )
{
	MOTOR_DA_Drive( DaBoard.sDA );
}

void ProcPIOA( void )
{
	// f[^o
	PA0_OUT = PioBoardA.Bit.P0;
	PA1_OUT = PioBoardA.Bit.P1;
	PA2_OUT = PioBoardA.Bit.P2;
	PA3_OUT = PioBoardA.Bit.P3;
	PA4_OUT = PioBoardA.Bit.P4;
	PA5_OUT = PioBoardA.Bit.P5;
	PA6_OUT = PioBoardA.Bit.P6;
	PA7_OUT = PioBoardA.Bit.P7;

	// o͕
	PA0_DIR = PioBoardA.Bit.DIR0;
	PA1_DIR = PioBoardA.Bit.DIR1;
	PA2_DIR = PioBoardA.Bit.DIR2;
	PA3_DIR = PioBoardA.Bit.DIR3;
	PA4_DIR = PioBoardA.Bit.DIR4;
	PA5_DIR = PioBoardA.Bit.DIR5;
	PA6_DIR = PioBoardA.Bit.DIR6;
	PA7_DIR = PioBoardA.Bit.DIR7;

	// ̓f[^i[
	PioBoardA.Bit.P0 = PA0_IN;
	PioBoardA.Bit.P1 = PA1_IN;
	PioBoardA.Bit.P2 = PA2_IN;
	PioBoardA.Bit.P3 = PA3_IN;
	PioBoardA.Bit.P4 = PA4_IN;
	PioBoardA.Bit.P5 = PA5_IN;
	PioBoardA.Bit.P6 = PA6_IN;
	PioBoardA.Bit.P7 = PA7_IN;
}

void ProcPIOB( void )
{
	// f[^o
	PB0_OUT = PioBoardB.Bit.P0;
	PB1_OUT = PioBoardB.Bit.P1;
	PB2_OUT = PioBoardB.Bit.P2;
	PB3_OUT = PioBoardB.Bit.P3;
	PB4_OUT = PioBoardB.Bit.P4;
	PB5_OUT = PioBoardB.Bit.P5;
	PB6_OUT = PioBoardB.Bit.P6;
	PB7_OUT = PioBoardB.Bit.P7;
	PB8_OUT = PioBoardB.Bit.P8;
	PB9_OUT = PioBoardB.Bit.P9;

	// o͕
	PB0_DIR = PioBoardB.Bit.DIR0;
	PB1_DIR = PioBoardB.Bit.DIR1;
	PB2_DIR = PioBoardB.Bit.DIR2;
	PB3_DIR = PioBoardB.Bit.DIR3;
	PB4_DIR = PioBoardB.Bit.DIR4;
	PB5_DIR = PioBoardB.Bit.DIR5;
	PB6_DIR = PioBoardB.Bit.DIR6;
	PB7_DIR = PioBoardB.Bit.DIR7;
	PB8_DIR = PioBoardB.Bit.DIR8;
	PB9_DIR = PioBoardB.Bit.DIR9;

	// ̓f[^i[
	PioBoardB.Bit.P0 = PB0_IN;
	PioBoardB.Bit.P1 = PB1_IN;
	PioBoardB.Bit.P2 = PB2_IN;
	PioBoardB.Bit.P3 = PB3_IN;
	PioBoardB.Bit.P4 = PB4_IN;
	PioBoardB.Bit.P5 = PB5_IN;
	PioBoardB.Bit.P6 = PB6_IN;
	PioBoardB.Bit.P7 = PB7_IN;
	PioBoardB.Bit.P8 = PB8_IN;
	PioBoardB.Bit.P9 = PB9_IN;
}

void Control(void)
{
	if( sOutputDataSize_PA > 0 )
		CM_ReadBuf( pOutputData_PA, sOutputDataSize_PA );
	if( sOutputDataSize_PB > 0 )
		CM_ReadBuf( pOutputData_PB, sOutputDataSize_PB );

	switch(bBoardID_PA){
		case ENC_BOARD:		ProcEncoder();break;
		case SENSOR_BOARD:	ProcSensor(); break;
		case PIO_BOARD: 	ProcPIOA();   break;
		default: ; break;
		}
	switch( bBoardID_PB ){
		case PWM_BOARD: ProcPWM();  break;
		case DA_BOARD:  ProcDA();   break;
		case PIO_BOARD: ProcPIOB(); break;
		default: ; break;
	}
	
	if( sInputDataSize_PA > 0 )
		CM_WriteBuf( pInputData_PA, sInputDataSize_PA );
	if( sInputDataSize_PB > 0 )
		CM_WriteBuf( pInputData_PB, sInputDataSize_PB );

// M
	CM_PrepareReply();
}

void PresetData(void)
{
	switch(bBoardID_PA){
		case ENC_BOARD:		ProcEncoder();break;
		case SENSOR_BOARD:	ProcSensor(); break;
		case PIO_BOARD: 	ProcPIOA();   break;
		default: ; break;
		}
	switch( bBoardID_PB ){
		case PWM_BOARD: ProcPWM();  break;
		case DA_BOARD:  ProcDA();   break;
		case PIO_BOARD: ProcPIOB(); break;
		default: ; break;
	}
	
	if( sInputDataSize_PA > 0 )
		CM_WriteBuf( pInputData_PA, sInputDataSize_PA );
	if( sInputDataSize_PB > 0 )
		CM_WriteBuf( pInputData_PB, sInputDataSize_PB );

// M
	CM_PrepareReply();
}


void Init( void )
{
	TRIS_LED = 0; // output

	sInputDataSize_PA = 0;
	pInputData_PA = NULL;
	sOutputDataSize_PA = 0;
	pOutputData_PA = NULL;
	sInputDataSize_PB = 0;
	pInputData_PB = NULL;
	sOutputDataSize_PB = 0;
	pOutputData_PB = NULL;

	bBoardID_PA = (BYTE)( 0x03& (PORTC >> 13));
	bBoardID_PB = (BYTE)( 0x03& (PORTF >> 4));

	switch( bBoardID_PA){
	case ENC_BOARD:
		AD_Open();
		ENCODER_Open();

		sInputDataSize_PA = CM01_INPUT_ENC_SIZE;
		pInputData_PA = (BYTE*)&EncBoard;
		break;
	case SENSOR_BOARD:
		AD_Open();

		sInputDataSize_PA = CM01_INPUT_SENSOR_SIZE;
		pInputData_PA = (BYTE*)&SensorBoard;
		break;
	case PIO_BOARD:
		PioBoardA.Word.wDir = 0xffff;
		PioBoardA.Word.wData = 0x0000;
		sInputDataSize_PA = CM01_INPUT_PIO_SIZE;
		pInputData_PA = (BYTE*)&PioBoardA;
		sOutputDataSize_PA = CM01_OUTPUT_PIO_SIZE;
		pOutputData_PA = (BYTE*)&PioBoardA;
		ADPCFG = 0xffff; //
		break;
	default:
		PioBoardA.Word.wDir = 0xffff;
		PioBoardA.Word.wData = 0x0000;
		bBoardID_PA = PIO_BOARD;
		sInputDataSize_PA = CM01_INPUT_PIO_SIZE;
		pInputData_PA = (BYTE*)&PioBoardA;
		sOutputDataSize_PA = CM01_OUTPUT_PIO_SIZE;
		pOutputData_PA = (BYTE*)&PioBoardA;
		break;
	}
	switch( bBoardID_PB ){
	case PWM_BOARD:
		MOTOR_Open();

		PwmBoard.sPwm1 = 0;
		PwmBoard.sPwm2 = 0;
		sOutputDataSize_PB = CM01_OUTPUT_PWM_SIZE;
		pOutputData_PB = (BYTE*)&PwmBoard;
		break;
	case DA_BOARD:
		MOTOR_DA_Open();

		DaBoard.sDA = 0;
		sOutputDataSize_PB = CM01_OUTPUT_DA_SIZE;
		pOutputData_PB = (BYTE*)&DaBoard;
		break;
	case PIO_BOARD:
		PioBoardB.Word.wDir = 0xffff;
		PioBoardB.Word.wData = 0x0000;
		sInputDataSize_PB = CM01_INPUT_PIO_SIZE;
		pInputData_PB = (BYTE*)&PioBoardB;
		sOutputDataSize_PB = CM01_OUTPUT_PIO_SIZE;
		pOutputData_PB = (BYTE*)&PioBoardB;
		break; // PIO board
	default:
		PioBoardB.Word.wDir = 0xffff;
		PioBoardB.Word.wData = 0x0000;
		bBoardID_PB = PIO_BOARD;	
		sInputDataSize_PB = CM01_INPUT_PIO_SIZE;
		pInputData_PB = (BYTE*)&PioBoardB;
		sOutputDataSize_PB = CM01_OUTPUT_PIO_SIZE;
		pOutputData_PB = (BYTE*)&PioBoardB;
		break; // PIO board
	}
	
	CM_Init(); // ʐM@\,f[^obt@̏C^C}Jn
	PresetData();
}

void GetConfig( void )
{
	WORD wSize;

	CM_WriteBuf( &bBoardID_PA, 1 );
	CM_WriteBuf( &bBoardID_PB, 1 );
	wSize = sInputDataSize_PA + sInputDataSize_PB;
	CM_WriteBuf( (BYTE*)&wSize, 2 );
	wSize = sOutputDataSize_PA + sOutputDataSize_PB;
	CM_WriteBuf( (BYTE*)&wSize, 2 );
	
	CM_Reply();
}

void ClearData( void )
{
	ENCODER_ClearCounter();
	CM_Reply();
}

void SyncCommandProc(void)
{
	BYTE bCommand;

	// obt@ɓǂݍ܂ꂽR}h̓ǂݏoƑM
	CM_ChangeRxBuffer();
	CM_ReadBuf( &bCommand, 1 );
	switch(bCommand){
	case CM_OPEN:		CM_Open(); break;
	case CM_CLOSE:		CM_Close();	break;
	case CM_RESET:		CM_Reset(); break;
	case CM_PING:		CM_Ping(); break;
	case CM_SET_ID: 	CM_SetID(); break;
	case CM_GET_ID:		CM_GetID(); break;
	case CM_GET_VER:	CM_GetVer(); break;
	case CM_BLINK:		CM_Blink(); break;
	case CM_SET_PARAM:	CM_SetParam(); break;
	case CM_GET_PARAM:	CM_GetParam(); break;
	case CM01_GET_CONFIG: GetConfig(); break;
	case CM01_CLEAR_DATA: ClearData(); break;
	default:
		CM_bStatus = CM_COMMAND_UNDEFINED;
		CM_Reply();
		break;
	}

	CM_Rearm();	// M̏
}

// 񓯊R}h
void AsyncCommandProc(void)
{
	BYTE bCommand;

	// obt@ɓǂݍ܂ꂽR}h̓ǂݏoƑM

	CM_ChangeRxBuffer();
	CM_ReadBuf( &bCommand, 1 );

	switch( bCommand ){
	case CM01_EXCHANGE:
		Control();
		break;
	default:
		break;
	}
}

void ProcStatus( void )
{
	switch( CM_bStatus ){
	case CM_NORMAL: UT_StatusBlink(1000, 1, 1); break;
	case CM_COMMAND_UNDEFINED: UT_StatusBlink(250, 1, 3); break;
	case CM_COMMAND_RX_TIMEOUT: UT_StatusBlink(250, 2, 3 ); break;	
	case CM_COMMAND_SUM_ERROR: UT_StatusBlink(250, 3, 3 );  break;
	case CM_REPLY_TX_TIMEOUT: UT_StatusBlink(250, 4, 3 ); break;	
	case CM_REPLY_ERROR+ESPI_SCK_HUNGUP:
	case CM_COMMAND_ERROR+ESPI_SCK_HUNGUP: UT_StatusBlink( 250, 5, 3); break;
	case CM_REPLY_ERROR+ESPI_CS_HUNGUP:
	case CM_COMMAND_ERROR+ESPI_CS_HUNGUP: UT_StatusBlink( 250, 6, 3); break;
	}
}

int main(void)
{
	Init();
	UT_StatusBlink( 250, 2, 2 );
	
	while(1){
		if( CM_SyncCommandReady ){ // ^@ߎMóf[^M
			SyncCommandProc();
			PresetData();
			CM_SyncCommandReady = FALSE;
			UT_StatusBlink( 25, 1, 2 );
		}else if( CM_AsyncCommandReady ){ // 񓯊^@ߎMf[^M@Ao
			AsyncCommandProc();
			CM_AsyncCommandReady = FALSE;
			UT_StatusBlink( 25, 1, 2 );
		}

		if( UT_ControlTrig ){
			if( bBoardID_PA == ENC_BOARD ) ENCODER_GetRelativeCount();

			ProcStatus();
			UT_ControlTrig = FALSE;
		}

	}
}

